/* parse.h - IRC protocol parsing
 * Copyright 2000-2002 srvx Development Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: parse.h,v 1.8.4.3.2.2 2002/03/04 03:50:28 sailorfrag Exp $
 */

#ifndef PARSE_H
#define PARSE_H

typedef void (*chanmsg_func_t) (struct userNode *user, struct chanNode *chan, char *text);
void reg_chanmsg_func(unsigned char prefix, struct userNode *service, chanmsg_func_t handler);

typedef void (*privmsg_func_t) (struct userNode *user, struct userNode *target, char *text, int server_qualified);
void reg_privmsg_func(unsigned int numeric, privmsg_func_t handler);
void reg_notice_func(unsigned int numeric, privmsg_func_t handler);

typedef void (*mode_change_func_t) (struct chanNode *channel, struct userNode *user, int change_type, void *change);
void reg_mode_change_func(mode_change_func_t handler);

#define MODE_CHANGE_MISC	0x001
#define MODE_CHANGE_OP		0x002
#define MODE_CHANGE_DEOP       	0x004
#define MODE_CHANGE_BAN       	0x008

extern struct userList dead_users;

void init_parse(void);
int parse_line(unsigned char *line, int recursive);

typedef void (*foreach_chanfunc) (struct chanNode *chan, void *data);
typedef void (*foreach_nonchan) (char *name, void *data);
typedef void (*foreach_userfunc) (struct userNode *user, void *data);
typedef void (*foreach_nonuser) (char *name, void *data);
void parse_foreach(char *target_list, foreach_chanfunc cf, foreach_nonchan nc, foreach_userfunc uf, foreach_nonuser nu, void *data);

#endif
